/**
* {{#description}}{{.}}{{/description}}{{^description}}{{classname}}{{/description}}
*/{{#description}}
@ApiModel(description = "{{{description}}}"){{/description}}
public class {{classname}} {{#parent}}extends {{{parent}}} {{/parent}}{{#parcelableModel}}implements Parcelable {{#serializableModel}}, Serializable {{/serializableModel}}{{/parcelableModel}}{{^parcelableModel}}{{#serializableModel}}implements Serializable {{/serializableModel}}{{/parcelableModel}}{

{{#vars}}
{{#isEnum}}
 {{^isContainer}}
{{>modelInnerEnum}}
{{/isContainer}}
{{/isEnum}}
{{#items.isEnum}}
{{#items}}
{{^isContainer}}
{{>modelInnerEnum}}
{{/isContainer}}
{{/items}}
{{/items.isEnum}}
{{#isContainer}}
    protected {{{datatypeWithEnum}}} {{name}}{{#required}} = {{{defaultValue}}}{{/required}}{{^required}} = null{{/required}};
{{/isContainer}}
{{^isContainer}}
    protected {{{datatypeWithEnum}}} {{name}} = {{{defaultValue}}};
{{/isContainer}}
{{/vars}}

{{#parentVars}}
    /**
    * Quick Set {{name}}
    * Useful setter to use in builder style (eg. my{{classname}}.{{name}}({{{datatypeWithEnum}}}).anotherQuickSetter(..))
    * @param {{{datatypeWithEnum}}} {{name}}
    {{#minimum}}
        * minimum: {{minimum}}
    {{/minimum}}
    {{#maximum}}
        * maximum: {{maximum}}
    {{/maximum}}
    * @return {{classname}} The modified {{classname}} object
    **/
    public {{classname}} {{name}}({{{datatypeWithEnum}}} {{name}}) {
        this.{{name}} = {{name}};
        return this;
    }

    {{#isListContainer}}
    public {{classname}} add{{nameInCamelCase}}Item({{{items.datatypeWithEnum}}} {{name}}Item) {
        super.add{{nameInCamelCase}}Item({{name}}Item);
        return this;
    }

    {{/isListContainer}}
    {{#isMapContainer}}
    public {{classname}} put{{nameInCamelCase}}Item(String key, {{{items.datatypeWithEnum}}} {{name}}Item) {
        super.put{{nameInCamelCase}}Item(key, {{name}}Item);
        return this;
    }
    {{/isMapContainer}}
{{/parentVars}}

{{#vars}}
    {{^isReadOnly}}
    /**
    * Quick Set {{name}}
    * Useful setter to use in builder style (eg. my{{classname}}.{{name}}({{{datatypeWithEnum}}}).anotherQuickSetter(..))
    * @param {{{datatypeWithEnum}}} {{name}}
    {{#minimum}}
    * minimum: {{minimum}}
    {{/minimum}}
    {{#maximum}}
    * maximum: {{maximum}}
    {{/maximum}}
    * @return {{classname}} The modified {{classname}} object
    **/
    public {{classname}} {{name}}({{{datatypeWithEnum}}} {{name}}) {
        this.{{name}} = {{name}};
        return this;
    }

    {{#isListContainer}}
    public {{classname}} add{{nameInCamelCase}}Item({{{items.datatypeWithEnum}}} {{name}}Item) {
        {{^required}}
        if (this.{{name}} == null) {
            this.{{name}} = {{{defaultValue}}};
        }
        {{/required}}
        this.{{name}}.add({{name}}Item);
        return this;
    }

    {{/isListContainer}}
    {{#isMapContainer}}
    public {{classname}} put{{nameInCamelCase}}Item(String key, {{{items.datatypeWithEnum}}} {{name}}Item) {
        {{^required}}
        if (this.{{name}} == null) {
            this.{{name}} = {{{defaultValue}}};
        }
        {{/required}}
        this.{{name}}.put(key, {{name}}Item);
        return this;
    }

    {{/isMapContainer}}
    {{/isReadOnly}}
    /**
    {{#description}}
    * {{{description}}}
    {{/description}}
    {{^description}}
    * Get {{name}}
    {{/description}}
    {{#minimum}}
    * minimum: {{minimum}}
    {{/minimum}}
    {{#maximum}}
    * maximum: {{maximum}}
    {{/maximum}}
    * @return {{{datatypeWithEnum}}} {{name}}
    **/
    @ApiModelProperty({{#example}}example = "{{{example}}}", {{/example}}{{#required}}required = {{required}}, {{/required}}value = "{{{description}}}")
    public {{{datatypeWithEnum}}} {{getter}}() {
        return {{name}};
    }

{{^isReadOnly}}
    /**
    {{#description}}
    * {{{description}}}
    {{/description}}
    {{^description}}
    * Set {{name}}
    * @param {{{datatypeWithEnum}}} {{name}}
    {{/description}}
    {{#minimum}}
    * minimum: {{minimum}}
    {{/minimum}}
    {{#maximum}}
    * maximum: {{maximum}}
    {{/maximum}}
    **/
    public void {{setter}}({{{datatypeWithEnum}}} {{name}}) {
        this.{{name}} = {{name}};
    }

{{/isReadOnly}}
{{/vars}}
    @Override
    public boolean equals(java.lang.Object o) {
        if (this == o) {
            return true;
        }
        if (o == null || getClass() != o.getClass()) {
            return false;
        }{{#hasVars}}
        {{classname}} {{classVarName}} = ({{classname}}) o;
        return {{#vars}}Objects.equals(this.{{name}}, {{classVarName}}.{{name}}){{#hasMore}} &&
        {{/hasMore}}{{/vars}}{{#parent}} &&
        super.equals(o){{/parent}};{{/hasVars}}{{^hasVars}}
        return {{#parent}}super.equals(o){{/parent}}{{^parent}}true{{/parent}};{{/hasVars}}
    }

    @Override
    public int hashCode() {
        return Objects.hash({{#vars}}{{name}}{{#hasMore}}, {{/hasMore}}{{/vars}}{{#parent}}{{#hasVars}}, {{/hasVars}}super.hashCode(){{/parent}});
    }
}
